﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class FicFileCandidates : CandidatesGenerator
	{
		string file;
		
		public FicFileCandidates(string file)
		{
			this.file = file;
		}

		protected override ThreadSafeQueue<Community> generate(ThreadSafeQueue<Community> queue)
		{
			FicReader reader = new FicReader(file, graph);
			HashSet<Community> set = reader.read();
			foreach (Community c in set)
				queue.Enqueue(c);
			return queue;
		}

		public override string abbr()
		{
			return "ff-" + (smartStart ? "y" : "n");
		}
	}
}
