﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public abstract class Classifier
	{
		public bool classify(BitArray values)
		{
			return classify(values, 0);
		}
		public abstract bool classify(BitArray values, int row);

		public int[] quality(BinaryMatrix data, HashSet<int> trueRows)
		{
			int fp = 0, tp = 0, fn = 0, tn = 0;
			for (int i = 0; i < data.M; i++)
			{
				BitArray row = data.getRow(i);
				bool classLabel = classify(row);
				if (classLabel)
				{
					if(trueRows.Contains(i))
						tp++;
					else
						fp++;
				}
				else
				{
					if(trueRows.Contains(i))
						fn++;
					else
						tn++;
				}
			}
			return new int[] { tp, fp, tn, fn };
		}

		public double precision(int[] qualityData)
		{
			double p = ((double)qualityData[0]) / (qualityData[0] + qualityData[1]);
			return p;
		}

		public double recall(int[] qualityData)
		{
			double r = ((double)qualityData[0]) / (qualityData[0] + qualityData[3]);
			return r;
		}

	}
}
