﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class ItemSet
	{
		HashSet<int> items;
		public int count;

		public ItemSet(int count)
		{
			items = new HashSet<int>();
			this.count = count;
		}

		public override int GetHashCode()
		{
			int hash = 0;
			foreach (int i in items)
			{
				hash = hash ^ i;
			}
			return hash;
		}

		public override bool Equals(object o)
		{
			ItemSet set = (ItemSet)o;
			if (items.IsSubsetOf(set.items) && set.items.IsSubsetOf(items))
			{
				return true;
			}
			return false;
		}

		public void Add(int i)
		{
			items.Add(i);
		}

		public override string ToString()
		{
			string s = items.Count+": ";
			foreach (int i in items)
				s += i + " ";
			s += "(" + count + ")";
			return s;
		}
	}
}
