﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	abstract class ImpurityMeasure
	{
		public override string ToString()
		{
			string name = this.GetType().Name;
			return name.Substring(name.LastIndexOf('.') + 1);
		}

		public double impurity(double t, double f)
		{
			return impurity(t,f,t+f);
		}

		protected abstract double impurity(double t, double f, double total);
	}

	class GiniIndex : ImpurityMeasure
	{
		protected override double impurity(double t, double f, double total)
		{
			return (t / total) * (f / total);
		}
	}

	class ResubstitutionError : ImpurityMeasure
	{
		protected override double impurity(double t, double f, double total)
		{
			return 1.0 - Math.Max(t, f) / total;
		}

	}

}
