﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class DisjunctionClassifier : Classifier
	{
		public List<DisjunctionPattern> patterns;

		public DisjunctionClassifier(List<DisjunctionPattern> patterns)
		{
			this.patterns = patterns;
		}

		public override bool classify(BitArray values, int row)
		{
			foreach (DisjunctionPattern pattern in patterns)
			{
				if (values.contains(pattern.pattern))
					return true;
			}
			return false;
		}
	}
}
