﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class UndirectedGraphHybrid : UndirectedGraph
	{
		UndirectedGraphList list;
		UndirectedGraphMatrix matrix;

		public UndirectedGraphHybrid(int size) : base(size){}
		public UndirectedGraphHybrid(string path) : base(path) {}

		override protected void init(int size)
		{
			list = new UndirectedGraphList(size);
			matrix = new UndirectedGraphMatrix(size);
		}

		override public HashSet<int> getNeighbours(int v)
		{
			return list.getNeighbours(v);
		}

		override public void addEgde(int u, int v)
		{
			list.addEgde(u, v);
			matrix.addEgde(u, v);
		}

		override public void removeEdge(int u, int v)
		{
			list.removeEdge(u, v);
			matrix.removeEdge(u, v);
		}
		override public bool isEdge(int u, int v)
		{
			return matrix.isEdge(u, v);
		}
	}
}
