﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class UndirectedGraphList : UndirectedGraph
	{
		HashSet<int>[] vertices;

		public UndirectedGraphList(int size) : base(size){}
		public UndirectedGraphList(string path) : base(path) { }

		protected override void init(int size)
		{
			vertices = new HashSet<int>[size];
			for (int i = 0; i < size; i++)
			{
				vertices[i] = new HashSet<int>();
			}
		}

		override public HashSet<int> getNeighbours(int v)
		{
			return vertices[v];
		}

		override public void addEgde(int u, int v)
		{
			vertices[u].Add(v);
			vertices[v].Add(u);
			degreeTable[u] = vertices[u].Count;
			degreeTable[v] = vertices[v].Count;
			degreeTableChanged = true;
		}

		override public void removeEdge(int u, int v)
		{
			vertices[u].Remove(v);
			vertices[v].Remove(u);
			degreeTable[u] = vertices[u].Count;
			degreeTable[v] = vertices[v].Count;
			degreeTableChanged = true;
		}

		override public bool isEdge(int u, int v)
		{
			return vertices[u].Contains(v);
		}
	}
}
