﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CommunityDetection
{
	public class ThreadSafeQueue<T>
	{
		private Queue<T> queue;
		
		public ThreadSafeQueue()
		{
			queue = new Queue<T>();
		}

		public Queue<T> UnsafeQueue
		{
			get
			{
				return queue;
			}
		}

		public T Dequeue()
		{
			lock (queue)
			{
				return queue.Dequeue();
			}
		}

		public void Enqueue(T item)
		{
			lock (queue)
			{
				queue.Enqueue(item);
			}
		}

		public int Count
		{
			get
			{
				lock (queue)
				{
					return queue.Count;
				}
			}
		}

		public bool Empty()
		{
			lock (queue)
			{
				return queue.Count == 0;
			}
		}


		public void Clear()
		{
			lock (queue)
			{
				queue.Clear();
			}
		}
	}
}
